;;; aMoveTxt.lsp -   
;;;
;;; Copyright (C) 2001 by AlexSoft, Babishuk A.V. ( )
;;; E-Mail: alexbabichuk@hotmail.com
;;;
;;; C:AMT - formats multitext with the AutoCAD Release 2000 User Menu.
;;;
;;; command:   ^C^C(load "aMoveTxt") aMT 
;;;_____________________________________________________________________________

(defun get_first ()
  (setq y2 10000000000000000)
  (setq kol (sslength ssold))
  (while (/= kol 0)
    (setq kol (- kol 1))
    (setq nme (ssname ssold kol))
    (setq y1 (nth 2 (assoc 10 (entget nme))))
    (if	(< y1 y2)
      (progn
	(setq y2 y1)
	(setq frst_ent nme)
      )					;progn
    )					;if
  )					;while
)

;;;  
(defun aMT_Dialog ()
  (setq dcl_id (load_dialog "aMoveTxt.dcl"))

  (if (not (new_dialog "aMoveTxt" dcl_id))
    (exit)
  )

  (set_tile "koord_x" (rtos x0 2))
  (set_tile "koord_y" (rtos y0 2))
  (set_tile "dist_y" (rtos dist 2))

  (action_tile "koord_x" "(setq x0 $value)")
  (action_tile "koord_y" "(setq y0 $value)")
  (action_tile "dist_y" "(setq dist $value)")

  (action_tile "accept" "(done_dialog 1) (setq ok_button T)")
  (action_tile
    "cancel"
    "(done_dialog 0) (setq ok_button nil)"
  )
  (start_dialog)
)

(defun c:amt (/ name ssold ssnew frst_ent kol nme x0 y0 y1 y2 dist)
  (setvar "cmdecho" 0)
  (setq ssold (ssget '((0 . "text"))))
  (setq kol (sslength ssold))
  (if (and (/= kol 1) (/= kol 0))
    (progn
      (setq ssnew (ssadd))
      (while ssold
	(get_first)
	(setq ssold (ssdel frst_ent ssold))
	(ssadd frst_ent ssnew)
      )
      (setq ssold ssnew
	    kol	  (sslength ssold)
	    nme	  (ssname ssold (- kol 1))
	    y0	  (nth 2 (assoc 10 (entget nme)))
	    x0	  (nth 1 (assoc 10 (entget nme)))
      )
      (setq nme	(ssname ssold (- kol 2))
	    y1	(nth 2 (assoc 10 (entget nme)))
      )

      (setq dist      (abs (- y0 y1))
	    ok_button T
      )

      (aMT_Dialog)
      (if (= ok_button T)
	(PROGN
	  (if (= (type x0) 'STR)
	    (setq x0 (atof x0))
	  )
	  (if (= (type y0) 'STR)
	    (setq y0 (atof y0))
	  )
	  (if (= (type dist) 'STR)
	    (setq dist (atof dist))
	  )

	  (while (/= kol 0)
	    (setq kol (- kol 1)
		  nme (entget (ssname ssold kol))
		  nme (subst (list 10 x0 y0) (assoc 10 nme) nme)
		  y0  (- y0 dist)
	    )
	    (entmod nme)
	  )
	  (princ)
	)
      )
    )
  )
)
