//---------------------------------------------------------------------
//   ADIMEDIT.DCL   Version 1.0
//   Copyright (C) 2001 by Windenergo Ltd, Babichuk A.V.
//---------------------------------------------------------------------
//   ADIMEDIT.DCL - Dialog for Edit Dimension.
//---------------------------------------------------------------------
//  ADIMEDIT dialogue.  Used by the "DEA" command in 
//  ADIMEDIT.LSP.

dcl_setting: default_dcl_settings {audit_level=0;}

adimedit: dialog {
  aspect_ratio=0;
  label= "WindEnergo Dimension Editor";
  :column {
    :boxed_row {
      label= " ";
      :edit_box {
         key="edit1";
         label=" ";
         edit_width=20;
      }
      :column {
        :edit_box {
           key="toler1";
           edit_width=5;
        }
        :edit_box {
           key="toler2";
           edit_width=5;
        }
      }
      :edit_box {
         key="edit2";
         edit_width=5;
      }
      :column {
        :toggle {
           key="block1";
           is_tab_stop=true;
        }
        :text {
           key   = "block2";
           value = ".";
        }
      }
    }
    :toggle {
       key="simm";
       label="-  ";
       is_tab_stop=true;
    }
    :row {
      :toggle {
         key="diam";
         label="-  ";
         is_tab_stop=true;
      }
      :toggle {
         key="degr";
         label="-  ";
         is_tab_stop=true;
      }
    }
    :row {
      :text {
         key   = "txt1";
         value = " ";
      }
      :edit_box {
         key="dim_txt";
      }
    }
    spacer;
    ok_cancel;
  }
}
