;;; aEdMulti.lsp -       Y   EDACAD.$$$
;;;        .
;;;
;;; Copyright (C) 2001 by AlexSoft, Babishuk A.V. ( )
;;; E-Mail: alexbabichuk@hotmail.com
;;;
;;; C:AEDM - edit multitext with the AutoCAD Release 2000 User Menu.
;;;
;;; command:   ^C^C(load "aEdMulti") aEDM 
;;;_____________________________________________________________________________

(defun get_first ()
  (setq y2 1000000000)
  (setq kol (sslength ssold))
  (while (/= kol 0)
    (setq kol (- kol 1))
    (setq nme (ssname ssold kol))
    (setq y1 (nth 2 (assoc 10 (entget nme))))
    (if	(< y1 y2)
      (progn
	(setq y2 y1)
	(setq frst_ent nme)
      )					;progn
    )					;if
  )					;while
)

(defun c:aedm (/ name ssold ssnew frst_ent kol txtfile nme txt y1 y2)
  (setvar "cmdecho" 0)
  (setq ssold (ssget '((0 . "text"))))
  (setq kol (sslength ssold))
  (if (= kol 1)
    (command "._DDEDIT" ssold "")
    (progn
      (setq name "c:\\temp\\edacad.$$$")
      (setq ssnew (ssadd))
      (while ssold
	(get_first)
	(setq ssold (ssdel frst_ent ssold))
	(ssadd frst_ent ssnew)
      )
      (setq ssold ssnew
	    kol	  (sslength ssold)
      )

      (setq txtfile (open name "w"))
      (if (/= ssold nil)
	(while (/= kol 0)
	  (setq kol (- kol 1))
	  (setq nme (ssname ssold kol))
	  (setq txt (cdr (assoc 1 (entget nme))))
	  (write-line txt txtfile)
	)
      )
      (close txtfile)
      (startapp "notepad" name)

      (getkword "\n ?")
      (setq txtfile (open name "r")
	    kol	    (sslength ssold)
	    txt	    (read-line txtfile)
      )
      (while (and (/= txt nil) (/= kol 0))
	(setq kol (- kol 1))
	(setq nme (entget (ssname ssold kol))
	      nme (subst (cons 1 txt) (assoc 1 nme) nme)
	      txt (read-line txtfile)
	)
	(entmod nme)
      )
      (close txtfile)
      (princ)
    )
  )
)
